    MEMBER()
		MAP
		module('')
			d_OutputDebugString(*CString),raw,pascal,Name('OutputDebugStringA')
		end
		d_dbg(String pDebugString)
	END

  include('ShowColClass.inc')
  include('keycodes.clw'),once

ShowColClass.Construct  PROCEDURE
  code
    SELF.ColQ &= new(TColumnQ)
    SELF.szResetAlltext = 'Reset ALL'
? assert(~SELF.ColQ &= null)    
    self.Popup &= new(Popupclass)
    if ~(self.Popup &= null)
        self.Popup.Init()
    end
  
    
ShowColClass.Destruct   PROCEDURE 
ndx     long 
  code
? assert(~SELF.ColQ &= null)
    if ~(SELF.ColQ &= null)
        free(SELF.ColQ)
        dispose(SELF.ColQ)
    end
    if ~(self.popup &= null)
       self.Popup.Kill()
       dispose(self.Popup)
    end

ShowColClass.Init   PROCEDURE (LONG pFEQ,String pIniFile)  
  code    
    d_dbg('Save Columns')  
    SELF.ListCtrl = clip(pFEQ) 
    self.inifile=clip(pIniFile)
    self.SetPreAlertKeys()
    SELF.InitColQ()    
    register(EVENT:PreAlertKey, address(SELF.OnPreAlertKey), address(SELF),,SELF.ListCtrl)  
    RETURN

ShowColClass.GetColOrderSettings   Procedure(*string pColOrderStr)
ndx     long
  code
    pColOrderStr = ''
    ndx = 1
    loop ndx = 1 to records(self.ColQ)
      get(self.ColQ, ndx)
      pColOrderStr = clip(pColOrderStr) & clip(self.ColQ.ColName) & ',' 
    end  
        
ShowColClass.ApplyColOrder  Procedure(string pColOrder)
TokenQ                        queue
Token                         string(25)
                              end
TmpStr                        &string
NoFound                       byte
ndx                           long
Pos                           long
TempColQ                      &TColumnQ
retValue                      long
  code
    if pColOrder
      TmpStr &= new(string(len(pColOrder)))
      TmpStr = pColOrder
      loop
        pos = instring(',', TmpStr[1 : len(clip(TmpStr))], 1, 1)
        if Pos
          TokenQ.Token = TmpStr[1 : Pos - 1]
          if TokenQ.Token
            add(TokenQ)
            if Pos = len(clip(TmpStr))
              break
            else
              TmpStr = TmpStr[Pos + 1 : len(clip(TmpStr))]
            end
          else
            break
          end
        else
          break
        end
      end
      ! After the pColOrder string has been parsed to ColName, check if the name or the number of column correspond to the listbox
      if records(TokenQ) <> records(self.ColQ)
        RetValue = false
      else
        ! Check to see if ColName corresponds to those in ColQ
        NoFound = false
        loop ndx = 1 to records(TokenQ)
          get(TokenQ, ndx) 
          self.ColQ.ColName = TokenQ.Token
          get(self.ColQ, self.ColQ.ColName)
            if errorcode()   ! ColName is not found, maybe list layout modified by the programmer since last use of the application    
            NoFound = true
            break
          end
        end
        if NoFound
           message('Your Columns layout had to be reset because the table version is updated.|Please close and reopen the window to see default Columns layout.','Exception')
           self.ClearIniEntry=true     
           RetValue = false !ReformatList() will not happen
        else
          if records(TOkenQ)
            RetValue = true
            ! Create a copy of the internal queue in the right order.
            ! The Col order is contained in TokenQ. So we loop to each or TokenQ record, grap the corresponding record
            ! in ColQ, copy the record in TmpQueue. At the end of that process, TmpQueue will be in the right order. Rebuild of ColQ
            ! will simply matter of free(ColQ) and loop through each TmpQueue record and copy back in ColQ.
            TempColQ &= new(TColumnQ)
            loop ndx = 1 to records(TokenQ)
              get(TokenQ, ndx)
              self.ColQ.ColName = TokenQ.Token
              get(self.ColQ, self.ColQ.ColName)
              if ~errorcode()
                TempColQ :=: self.ColQ
                add(TempColQ)
              else
                RetValue = false
              end
            end
            if records(TempColQ)
              free(self.ColQ)
              loop ndx = 1 to records(TempColQ)
                get(TempColQ, ndx)
                if ~errorcode()
                  self.ColQ :=: TempColQ
                  add(self.ColQ)
                  if errorcode()
                    RetValue = false
                  end
                else
                  RetValue = false
                end
              end
              ! At this point, ColQ is rebuild in the right order, we can generate the Format string of the listbox
              self.ReformatList()
            end
            free(TempColQ)    ! Free tempColQ records
            dispose(TempColQ) ! release reference
          end
        end
      end
      dispose(TmpStr) ! Release string copy of pColOrder
    end
    return(RetValue)
    
ShowColClass.InitColQ           procedure
ndx                             long
QField                          any
  code
    ndx = 1
    loop
      clear(SELF.ColQ)
      if SELF.ListCtrl{proplist:exists, ndx}
        SELF.ListCtrl{Proplist:resize,ndx} = true       ! Make all columns resizeable
        SELF.ListCtrl{PROPLIST:RightBorder,ndx} = true  ! Give all columns right border    
        SELF.ColQ.ColNbr = ndx
        SELF.ColQ.ColName = SELF.ListCtrl{proplist:Header, ndx}
        SELF.ColQ.Width = SELF.ListCtrl{proplist:width, ndx}
        SELF.ColQ.PosInQueue = SELF.ListCtrl{proplist:FieldNo, ndx}       
        SELF.ListCtrl{proplist:FieldNo, ndx} = SELF.ColQ.PosInQueue   ! Force the queue field no to appear in the format string       
        SELF.ColQ.ColListFormat = SELF.ListCtrl{proplist:format, ndx}
        add(SELF.ColQ, SELF.ColQ.ColNbr)
        ndx += 1
      else
        break
      end
    end  
  
ShowColClass.Kill procedure
  code
   unregister(EVENT:PreAlertKey, address(SELF.OnPreAlertKey), address(SELF),,SELF.ListCtrl)  
    
ShowColClass.OnPreAlertKey      procedure
MenuChoice                      long
Ndx                             long
windowcontrol                   long(0)
  code 
    if keycode() = MouseRight
      if field() = SELF.ListCtrl and SELF.ListCtrl{proplist:MouseDownRow} = 0
        if self.ClearIniEntry=false  
          if ~(SELF.Popup &= null)
           SELF.ColQ.ColNbr = SELF.ListCtrl{proplist:MouseDownField}            
           get(SELF.ColQ, SELF.ColQ.ColNbr)       
           self.GenPopupStr(self.ColQ.ColName) 
           SELF.Popup.Ask() !display popup         
           MenuChoice = popup(SELF.szColsPopup)
           if MenuChoice > records(SELF.ColQ)
               if MenuChoice = records(SELF.ColQ)+1
                 self.ShiftLeft
               elsif MenuChoice = records(SELF.ColQ)+2 
                 self.ResetAll()
               end  
           else
              SELF.ColQ.ColNbr = MenuChoice
              get(SELF.ColQ, SELF.ColQ.ColNbr)
              if ~errorcode()
                if ~SELF.ColQ.ColNbr=1  
                 SELF.ListCtrl{proplist:Width, SELF.ColQ.ColNbr} = choose(SELF.ColQ.Visible = true, 0, SELF.ColQ.Width)
                 SELF.ColQ.Visible = choose(SELF.ColQ.Visible = true, false, true)
                 put(SELF.ColQ)
                end   
             end                 
           end 
         end
        else
          message('Please close and reopen the window to see default Columns layout.','Reset ALL is active')  
        end
      end
    end
    
ShowColClass.SetPreAlertKeys     procedure
  code
    self.ListCtrl{prop:Alrt, 255} = MouseRight
        
ShowColClass.GenPopupStr         procedure(string pColumnname)
ndx     long
  code
    ndx = 1
    SELF.szColsPopup = ''
    loop ndx = 1 to records(SELF.ColQ)
      get(SELF.ColQ, ndx)   
      if ~errorcode()
        SELF.ColQ.Visible=choose(SELF.ListCtrl{proplist:Width, ndx} = 0, false, true) 
        put(SELF.ColQ)
      end
      if ndx=1
        SELF.szColsPopup = clip(SELF.szColsPopup) &  choose(SELF.ColQ.Visible = true, '+', '') & clip(SELF.ColQ.ColName)&'(Fixed)'& '|'
      else  
        SELF.szColsPopup = clip(SELF.szColsPopup) &  choose(SELF.ColQ.Visible = true, '+', '') & clip(SELF.ColQ.ColName) & '|'
      end  
    end
    !SELF.szColsPopup = clip(SELF.szColsPopup) &'|-|'    
    SELF.szColsPopup = clip(SELF.szColsPopup) &'< MOVE '&clip(pColumnname)&'|'      
    if SELF.szResetAlltext
      SELF.szColsPopup = clip(SELF.szColsPopup) & '|' & SELF.szResetAlltext
    end
                                                   
ShowColClass.ResetAll      procedure
ndx     long
  code
    loop ndx = 1 to records(SELF.ColQ)
      get(SELF.ColQ, ndx)
      if SELF.ColQ.Visible = false
        SELF.ColQ.Visible = true
        SELF.ListCtrl{proplist:width, SELF.ColQ.ColNbr} = SELF.ColQ.Width
        put(SELF.ColQ)
      end
    end
    message('Please close and reopen the window to see default Columns layout.','Reset ALL is active')                        
    self.ClearIniEntry=true
    
ShowColClass.ReformatList          procedure
! because the ColQ structure contains the Format string for each column of the list
! reformat the list is simply matter of looping and concatening each individual format string into one string
ndx                             long
FormatStr                       &string
StrLen                          long
  code
    ! First,check the len of the string needed to hold the complete format
    StrLen = 0
    loop ndx = 1 to records(SELF.ColQ)
      get(self.ColQ, ndx)
      StrLen += len(clip(SELF.ColQ.ColListFormat))
    end
    ! Create the string
    FormatStr &= new(string(StrLen + 1))
    if ~(FormatStr &= null)                                           ! String allocated ok?
      loop ndx = 1 to records(SELF.ColQ)                              ! Loop through all records in ColQ
        get(SELF.ColQ, ndx)                                           ! get the ColQ record
        SELF.ColQ.ColNbr = ndx                                        ! Set the ColNbr position
        FormatStr = clip(FormatStr) & clip(SELF.ColQ.ColListFormat)   ! Build the format string
        put(SELF.ColQ)                                                ! Update the ColQ record
      end
      SELF.ListCtrl{prop:Format} = clip(FormatStr)                    ! Apply the format string to the list
      dispose(FormatStr)                                              ! dispose the string
    end
 
ShowColClass.ShiftLeft      procedure
ndx            long
TmpCol         like(TColumnGrp)
TargetCol      long
SourceCol      long
HiddenColumns  String(1018)
  code
    ! Columns moving processing
    if field() = SELF.ListCtrl
      SELF.ColQ.ColNbr = SELF.ListCtrl{proplist:MouseDownField}                                           
      if SELF.ColQ.ColNbr=1
         !First column may not be moved do nothing
      else
         SourceCol=SELF.ColQ.ColNbr  
         get(SELF.ColQ, SourceCol-1)        ! Get Target Column 
         if SELF.ColQ.ColNbr=1
           message('Moving to the first (fixed) Column is not allowed','Exception') 
         else            
           loop ndx = SourceCol-1 to 2 by -1         !skip hidden columns left of the sourcecolumn
              get(SELF.ColQ, ndx)      
              if self.ColQ.Visible=true              ! target is not hidden
                 TargetCol=SELF.ColQ.ColNbr        
                 break   
              end
           end
           if TargetCol     
             self.GetHideSettings(HiddenColumns) 
             get(SELF.ColQ, TargetCol+1)             ! reget Colnbr to move     
             TmpCol :=: SELF.ColQ                    ! Save information                                    
             delete(SELF.ColQ)                       ! Delete it from the queue
             SELF.ColQ :=: TmpCol                    ! Reassign the ColQ structure
             if TargetCol <= records(SELF.ColQ)               
                add(SELF.ColQ, TargetCol)            ! Add it to the position corresponding to the drop           
             else
                add(SELF.ColQ)
             end
             assert(~errorcode())                    ! Just in case
             SELF.ReformatList()                     ! Reformat the list     
             if HiddenColumns     
                self.ApplyHide(HiddenColumns)
             end
           end     
        end   
      end
    end
    return(0)

   
ShowColClass.ColNamesWidthsIni  Procedure(Long pFEQ,String pEntry,Byte pDirection)!,Long
Ndx          Long
W            Long
ColumnWidth  String(3),DIM(255)
ColumnWidths String(Size(ColumnWidth)),Over(ColumnWidth)                               
ColumnNames  String(1018)  !MaxIniLine 1023 minus xxxx=
Columnnr     Long
  Code
  ColumnWidths = ''
  Case pDirection
  of 2 !from ini     
    ColumnWidths = GetINI('ShowCol',Clip(pEntry)&'x',,self.inifile)
    If NOT ColumnWidths
       self.ReformatList()    !if original has listheaders, don't show on first openingen
       Return 0  
    else
       ColumnNames=GetINI('ShowCol',Clip(pEntry)&'y',,self.inifile)
       self.ApplyColOrder(ColumnNames)! with reformatlist    
    end
  end
  Loop Ndx = 1 to 255
    If NOT pFEQ{PROPList:Exists,Ndx} then break.
      Case pDirection
      of 1 !to ini
         if pFEQ{PROPList:Group+PROPList:Width}>999
           ColumnWidth[Ndx]=999
         else       
           ColumnWidth[Ndx] = Format(pFEQ{PROPList:Group+PROPList:Width,Ndx},@n03)
         end       
      of 2 !from ini
        W = ColumnWidth[Ndx]
        If Clip(ColumnWidth[Ndx]) <> ''
          pFEQ{PROPList:Width,Ndx} = W
        end 
      end
  end
  Case pDirection
  of 1 !to ini
    if self.ClearIniEntry=false    
       self.GetColOrderSettings(ColumnNames)   
       PutINI('ShowCol',Clip(pEntry)&'x',ColumnWidths,self.inifile)    
       PutINI('ShowCol',Clip(pEntry)&'y',ColumnNames,self.inifile)
    else
       PutINI('ShowCol',Clip(pEntry)&'x','',self.inifile)    
       PutINI('ShowCol',Clip(pEntry)&'y','',self.inifile) 
    end    
  end
  Return Ndx    

ShowColClass.GetHideSettings     procedure(*string pHideStr)
ndx     long
    code
    pHideStr = ''
    ndx = 1
    loop ndx = 1 to records(self.ColQ)
      get(self.ColQ, ndx)
      if ~self.ColQ.Visible
        pHideStr = clip(pHideStr) & clip(self.ColQ.ColName) & ','
      end
    end   

ShowColClass.ApplyHide           procedure(string pHideStr)
TokenQ      queue
Token         string(25)
            end
TmpStr      &string
NoFound     byte
ndx         long

Pos         long

TempColQ    &TColumnQ

RetValue    long
    code
    if pHideStr
      TmpStr &= new(string(len(pHideStr)))
      TmpStr = pHideStr
      loop
        pos = instring(',', TmpStr[1 : len(clip(TmpStr))], 1, 1)
        if Pos
          TokenQ.Token = TmpStr[1 : Pos - 1]
          if TokenQ.Token
            add(TokenQ)
            if Pos = len(clip(TmpStr))
              break
            else
              TmpStr = TmpStr[Pos + 1 : len(clip(TmpStr))]
            end
          else
            break
          end
        else
          break
        end
      end

      loop ndx = 1 to records(TokenQ)
        get(TokenQ, ndx)
        self.ColQ.ColName = TokenQ.Token
        get(self.ColQ, self.ColQ.ColName)
        if ~errorcode()
          self.ListCtrl{proplist:Width, SELF.ColQ.ColNbr} = 0
          self.ColQ.Visible = false
          put(SELF.ColQ)
          !message(self.ColQ.colname&' '&self.ColQ.Visible)  
        end
      end

      dispose(TmpStr)

    end
    return(RetValue)
!---------------------------------------------------------------------------
d_dbg  PROCEDURE   (String pDebugString)  
DB  CSTRING(SIZE(pDebugString)+12) 
  CODE
  DB = 'd_columns: ' & pDebugString
  d_OutputDebugString(DB)
